<template>
  <div class="authentication">
    <div class="auth-form">
      <div class="auth-form-password">
        <input
          name="password"
          @keyup.enter="verifyCode"
          type="password"
          @focus="resetError"
          v-model="password"
          data-vv-validate-on="none"
          v-validate="'required'"
          :placeholder="$t('otp.removeOtp.placeholder.password')"
        >
        <span class="invalid-feedback" v-if="errors.has('password')">
          {{ errors.first('password') }}
        </span>
      </div>
      <div class="auth-form-code">
        <input
          name="code"
          v-validate="'required|length:6'"
          @keyup.enter="verifyCode"
          data-vv-as="OTP code"
          type="text"
          @focus="resetError"
          maxlength="6"
          @keypress="isNumber"
          v-model="code"
          data-vv-validate-on="none"
          :placeholder="$t('otp.removeOtp.placeholder.code')"
        >
        <span class="invalid-feedback" v-if="errors.has('code')">
          {{ errors.first('code') }}
        </span>
      </div>
    </div>
    <div class="clearfix"></div>
    <div class="auth-form-footer btn-group">
      <div class="btn-item">
        <button class="btn-step btn-prev-step" @click="$emit('previous')" type="button"><i class="fa fa-angle-left" aria-hidden="true"></i> {{ $t('otp.btnPrev') }}</button>
      </div>
      <div class="btn-item">
        <button type="button" class="btn-step btn-enable" @click="verifyCode">{{ $t('otp.btnEnable') }}</button>
      </div>
    </div>
  </div>
</template>
<script>
import { mapMutations } from 'vuex';

import OtpInputMixin from '../../../common/components/Otp/OtpInputMixin';
import rf from '../../../common/requests/RequestFactory';

export default {
  mixins: [OtpInputMixin],
  data () {
    return {
      password: '',
      code: '',
    };
  },
  methods: {
    ...mapMutations([
      'updateUser',
    ]),
    verifyCode() {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          rf.getRequest('UserRequest')
            .addSecuritySettingOtp({'code' : this.code, 'password': this.password})
            .then(res => {
              this.$toasted.show(this.$t('otp.addOtp.message.success'), {
                theme: 'bubble',
                position: 'top-right',
                duration : 2000,
              });
              this.updateUser(res.data);
              this.$router.push('/users/profileSetting');
            })
            .catch(error => {
              this.errors.clear();
              const errors = error.errors;
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
            });
        });
    }
  },
};
</script>
<style scoped lang="scss">
  @import '../../../../sass/mobile/app.scss';

  * {
    font-family: $font-family-home;
  }
  .authentication {
    .auth-form {
      margin-top: 16rem;
      width: 100%;
      input {
        width: 100%;
        height: 40rem;
        border-radius: 74rem;
        background-color: $white;
        border: 1rem solid $white;
        padding: 0 20rem;
        font-size: $small;
        &::placeholder {
          font-size: $small;
        }
      }
      span {
        font-size: 14rem;
        &.invalid-feedback {
          color: red;
          font-size: 12rem;
          left: 20px;
          position: absolute;
          bottom: -23rem;
        }
      }
    }
    .auth-form-password,
    .auth-form-code {
      position: relative;
      margin-bottom: 25rem;
    }
    .auth-form-footer {
      display: block;
      position: absolute;
      width: 100%;
      right: 6rem;
      bottom: 0;
    }
    .btn-step {
      outline: none;
    }
  }
</style>
